package org.hardknockjava.lesson19.example01;

import java.util.Date;
import java.util.Properties;

import javax.mail.Address;
import javax.mail.Authenticator;
import javax.mail.Message;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

public class MrPostman {

    public static void main(String[] args) {
        String host = "localhost";
        String port = "25";

        String user = "you";
        String fromEmail = user + "@hardknockjava.net";
        String password = "mypassword";
        String toEmail = "hardknockjava@gmail.com";

        // Get system properties
        Properties props = new Properties(System.getProperties());

        // Setup mail server properties
        props.setProperty("mail.smtp.host", host);
        props.setProperty("mail.smtp.port", port);
        props.setProperty("mail.transport.protocol", "smtp");

        // Create an Authenticator that will provide the credentials
        // for access to the mail server.
        Authenticator auth = new Authenticator() {
            protected PasswordAuthentication getPasswordAuthentication() {
                return new PasswordAuthentication(fromEmail, password);
            }
        };

        // Log on to the mail server named by the properties
        // and using the credentials.
        Session session = Session.getInstance(props, auth);
        session.setDebug(false);

        // This is our message. It's in HTML.
        String bodyText = "<style>table, tr, th, td {border: solid 1px}</style>" //
                + "\n <table>" //
                + "\n <thead style=\"border: solid 1px; background-color: yellow\" >" //
                + "\n   <tr>" //
                + "\n     <th>Company</th>" //
                + "\n     <th>Contact</th>" //
                + "\n     <th>Country</th>" //
                + "\n   </tr>" //
                + "\n </thead>" //
                + "\n   <tr>" //
                + "\n     <td>Alfreds Futterkiste</td>" //
                + "\n     <td>Maria Anders</td>" //
                + "\n     <td>Germany</td>" //
                + "\n   </tr>" //
                + "\n   <tr>" //
                + "\n     <td>Centro comercial Montezuma</td>" //
                + "\n     <td>Francisco Chang</td>" //
                + "\n     <td>Mexico</td>" //
                + "\n   </tr>" //
                + "\n </table>";

        // Call the sendMail() method.
        sendEmail(session, toEmail, fromEmail, "Hard Knock Java", "Hard Knock Java Test", bodyText);
    }

    public static void sendEmail(Session session, String toEmail, String fromEmail, String fromName, String subject,
            String body) {
        try {
            MimeMessage msg = new MimeMessage(session);

            // Create our one and only recipient address.
            // fromName is the name you see that identifies the
            // sender in the "from" line of an email.
            Address fromAddress = new InternetAddress(fromEmail, fromName);
            
            // Establish the sender's address and name.
            msg.setFrom(fromAddress);

            // setReplyTo requires an array of Addresses.
            // InternetAddress.parse() converts and single Address
            // into an array.
            msg.setReplyTo(InternetAddress.parse(fromEmail, false));

            // Set the subject.
            msg.setSubject(subject);
            
            // Set the message body and indicate that it's HTML.
            msg.setContent(body, "text/html");
            
            // Establish the send date.
            msg.setSentDate(new Date());

            // Set To, CC, and BCC recipients to the same email
            // address. The latter two are for illustration purposes.
            Address[] toAddresses = InternetAddress.parse(toEmail);
            msg.setRecipients(Message.RecipientType.TO, toAddresses);
            msg.setRecipients(Message.RecipientType.CC, toAddresses);
            msg.setRecipients(Message.RecipientType.BCC, toAddresses);

            // Send the message.
            Transport.send(msg);

            System.out.println("EMail Sent Successfully!!");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
